
dnl
dnl bench1.m4 : simple-minded benchmark for 68k engine
dnl
dnl

dnl
dnl macro forloop taken verbatim from GNU m4 man page.
dnl

define(`forloop',
        `pushdef(`$1', `$2')_forloop(`$1', `$2', `$3', `$4')popdef(`$1')')

define(`_forloop',
       `$4'`ifelse($1, `$3', ,
		   `define(`$1', incr($1))_forloop(`$1', `$2', `$3', `$4')')')

define(`repeat',`forloop(`i',1,`$1',`$2')')


    .sect text
    .sect rom
    .sect data
    .sect bss


    .sect text
    .extern _bench_nop
_bench_nop:
!    move.w #9,d1
!    bar0:
    move.w #9999,d0
    foo0:
repeat(100,`    nop
')
    dbf d0,foo0
!    dbf d1,bar0
    rts

    .extern _bench_move.wq
_bench_moveq:
!    move.w #9,d1
!    bar1:
    move.w #9999,d0
    foo1:
repeat(100,`    move.l #42,d2
')
    dbf d0,foo1
!    dbf d1,bar1
    rts
            
    .extern _bench_regs
_bench_regs:
!    move.w #9,d1
!    bar2:
    move.w #9999,d0
    foo2:
repeat(100,`    move.w d1,d2
')
    dbf d0,foo2
!    dbf d1,bar2
    rts

    .extern _bench_lregs
_bench_lregs:
    move.w #1,d1
    bar3:
    move.w #9999,d0
    foo3:
repeat(50,`    add.l d1,d2
')
    dbf d0,foo3
    dbf d1,bar3
    rts

    .extern _bench_abs
_bench_abs:
    move.w #3,d1
    bar4:
    move.w #9999,d0
    foo4:
repeat(25,`    move.l l,l
')
    dbf d0,foo4
    dbf d1,bar4
    rts
    
    .extern _bench_movem
_bench_movem:
    move.l a6,-(sp)
    move.l a7,a6
    sub.l #100,a6
    move.w #4999,d0
    foo5:
repeat(10,`    movem.l d1-a5,(a6)
    movem.l (a6),d1-a5
')    
    dbf d0,foo5
    add.l #100,a6
    move.l (sp)+,a6
    rts

    .extern _bench_stack
_bench_stack:
    move.w #24999,d0
    foo6:
repeat(40,`    pea 0x12345678  
    move.l (sp)+,d1
')
    dbf d0,foo6
    rts

    .extern _bench_bsr
_bench_bsr:
    move.w #24999,d0
    foo7:
    bsr l0
    dbf d0,foo7
    bra done
l0:
repeat(19,`    bsr l`'i
    rts
l`'i:
')
    rts
    done:
    rts

    .sect data
    .extern _t
_t: .data4 0
    .extern _l
_l: .data4 0
    .extern l
l: .data4 0

