dnl
dnl bench1.m4 : simple-minded benchmark for 68k engine
dnl
dnl
dnl

dnl
dnl macro forloop taken verbatim from GNU m4 man page.
dnl

define(`forloop',
        `pushdef(`$1', `$2')_forloop(`$1', `$2', `$3', `$4')popdef(`$1')')

define(`_forloop',
       `$4'`ifelse($1, `$3', ,
                   `define(`$1', incr($1))_forloop(`$1', `$2', `$3', `$4')')')

define(`repeat',`forloop(`i',1,`$1',`$2')')


    .sect text
    .sect rom
    .sect data
    .sect bss


	.sect text
	.def`'ine init_exceptions
init_exceptions:
! initialize vectors

	move.l #253,d0
	lea br_table,a0
	move.l a0,d1
	lea 0x8,a0
init_vec:
	add.l #4,d1
	move.l d1,(a0)+
	dbra d0,init_vec
	rts

br_table:
repeat(254, `dnl bsr exception, in word format
	.data2 0x6100
	.data2 exception - .
')
	nop
	nop
        
exception:
	move.l (a7)+,d0
	lea br_table,a0
	sub.l a0,d0
	lsr.w #2,d0
	add.l #2,d0
	move.l d0,d7	
	move.l #0x10000,a7
	move.w d7,-(a7)
	pea except_msg
	jsr _printf
	move.w d7,-(a7)
	jsr _exit
end:
	bra end

except_msg:
	.ascii "fatal: exception %d"
	.data1 10,0

